/*********************************************************************************
Version: 1.15
Copyright (C) 2014 Marco J. Umpiérrez Rodríguez

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


**********************************************************************************/

var map, 						// Variable del mapa
	WMS_layer,					// Capas WMS
	usuario, selectedFeature, lineColorVal, fillColorVal,	// Identificadores
	nLayersWFS, layersWFS, dataWFS,							// Capas WFS (vectoriales)
	saveStrategies,											// Variable de salvado
	navigate, editar, dibujar, borrado,	selectControl, highlightCtrl, selectCtrl,	// Controles Openlayer	
	isAPopUp, isAnUpdate, isANewFeature;											// Variables de estados
var lista_iconos;
var colores = ['#EFBA00','#FECE2F','#000000','#FF0000','#00FF00','#0000FF','#FFFF00','#00FFFF','#FF00FF','#C0C0C0','#FFFFFF'];
var strControles;	
			 
//set up the modification tools
var DeleteFeature = OpenLayers.Class(OpenLayers.Control, {
	initialize: function(layer, options) {
		OpenLayers.Control.prototype.initialize.apply(this, [options]);
		this.layer = layer;
		this.handler = new OpenLayers.Handler.Feature(
			this, layer, {click: this.clickFeature}
		);
	},
	clickFeature: function(feature) {
		// if feature doesn't have a fid, destroy it
		if(confirm("¿Está seguro que desea borrar el elemento?")){
			if(feature.fid == undefined) {
				this.layer.destroyFeatures([feature]);
			} else {
				feature.state = OpenLayers.State.DELETE;
				this.layer.events.triggerEvent("afterfeaturemodified",
				{feature: feature});
				feature.renderIntent = "select";
				this.layer.drawFeature(feature);
			}
		}
	},
	setMap: function(map) {
		this.handler.setMap(map);
		OpenLayers.Control.prototype.setMap.apply(this, arguments);
	},
	CLASS_NAME: "OpenLayers.Control.DeleteFeature"
});


var myStyles = new OpenLayers.StyleMap({
    "default": new OpenLayers.Style(null, {
        rules: [
            new OpenLayers.Rule({
                symbolizer: {
                    "Point": {
                        pointRadius: 10,
                        graphicName: "circle",
                        fillColor: "white",
                        fillOpacity: 0.25,
                        strokeWidth: 1,
                        strokeOpacity: 1,
                        strokeColor: "#efba00"
                    },
                    "Line": {
                        strokeWidth: '${strokewidth}',
                        strokeOpacity: 1,
                        strokeColor: '${lineacolor}',
                        strokeDashstyle: '${strokedashstyle}'
                    },
                    "Polygon": {
                        strokeWidth: 1,
                        strokeOpacity: 1,
                        fillColor: '${rellenocolor}',
                        strokeColor: '${lineacolor}'
                    }
                }
            })
        ]
    }),
    "select": new OpenLayers.Style(null, {
        rules: [
            new OpenLayers.Rule({
                symbolizer: {
                    "Point": {
                        pointRadius: 10,
                        graphicName: "circle",
                        fillColor: "white",
                        fillOpacity: 0.25,
                        strokeWidth: 2,
                        strokeOpacity: 1,
                        strokeColor: "#0000ff"
                    },
                    "Line": {
                        strokeWidth: 6,
                        strokeOpacity: 1,
                        strokeColor: "#0000ff"
                    },
                    "Polygon": {
                        strokeWidth: 2,
                        strokeOpacity: 1,
                        fillColor: "#0000ff",
                        strokeColor: "#0000ff"
                    }
                }
            })
        ]
    }),
    "temporary": new OpenLayers.Style(null, {
        rules: [
            new OpenLayers.Rule({
                symbolizer: {
                    "Point": {
                        graphicName: "circle",
                        pointRadius: 10,
                        fillColor: "white",
                        fillOpacity: 0.25,
                        strokeWidth: 2,
                        strokeColor: "#0000ff"
                    },
                    "Line": {
                        strokeWidth: 6,
                        strokeOpacity: 1,
                        strokeColor: "#12b317"
                    },
                    "Polygon": {
                        strokeWidth: 2,
                        strokeOpacity: 1,
                        strokeColor: "#12b317",
                        fillColor: "#57c75b"
                    }
                }
            })
        ]
    })
});

var GuaguaStyle = new OpenLayers.StyleMap({
	"default": new OpenLayers.Style({
		externalGraphic : "img/"+ '${icono}',
		graphicWidth : 30,
		graphicHeight: 30,
		graphicZIndex: 1	//¿es necesario?
	}),
	"select": new OpenLayers.Style({
		externalGraphic : "img/select_icon.png",
		graphicWidth : 30,
		graphicHeight: 30,
		graphicZIndex: 1
	}),
	"temporary": new OpenLayers.Style({
		externalGraphic : "img/" + '${icono}',
		graphicWidth : 40,
		graphicHeight: 40,
		graphicZIndex: 1
	}),
	"vertex": new OpenLayers.Style({
		externalGraphic : "img/select_icon.png",
		graphicWidth : 30,
		graphicHeight: 30,
		graphicZIndex: 1
	})
});



//////////////////////////////////////////////////////////////////////////////////////////////////////        
//////////////////////////////////////////////////////////////////////////////////////////////////////
// FUNCION READY
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////

$(function(){


	$.ajax({
            url: "http://193.145.155.8/consulta_wfs.php",
            async: false, // Evita que continue la ejecución hasta que se haya obtenido todo lo requerido
            success: function(result) {
               dataWFS = jQuery.parseJSON(result); // Sustituye strings por objetos
               for (var i = 0; i< dataWFS.length; i++) {
               		if(dataWFS[i][2] === "myStyles")
               			dataWFS[i][2] = myStyles;
               		if(dataWFS[i][2] === "GuaguaStyle")
               			dataWFS[i][2] = GuaguaStyle;

               		if(dataWFS[i][3] === "OpenLayers.Handler.Polygon")
               			dataWFS[i][3] = OpenLayers.Handler.Polygon;
               		if(dataWFS[i][3] === "OpenLayers.Handler.Path")
               			dataWFS[i][3] = OpenLayers.Handler.Path;
               		if(dataWFS[i][3] === "OpenLayers.Handler.Point")
               			dataWFS[i][3] = OpenLayers.Handler.Point;
               }
            }
    });

	$.ajax({
            url: "http://193.145.155.8/consulta_iconos.php",
            success: function(result) {
               lista_iconos = jQuery.parseJSON(result); // alert the output from the PHP Script
            }
    });
	nLayersWFS = dataWFS.length;


	// set up projections
	// World Geodetic System 1984 projection
	var WGS84 = new OpenLayers.Projection("EPSG:32628");
	// WGS84 Google Mercator projection
	var WGS84_google_mercator = new OpenLayers.Projection("EPSG:900913");  
	// Coordenada mínima y máxima del mapa entero (isla Gran Canaria)
	var bounds = new OpenLayers.Bounds(
		167311, 3053737, // Esquina inferior izquierda
		670738, 3265401	// Esquina superior derecha
		//416000, 3066000, 
		//466000, 3119000
	).transform(WGS84, WGS84_google_mercator);
	var zoom = 10;

	var options = {
		projection: "EPSG:32628", 
		units: 'm', 
		maxScale: 100, // Lo más cerca del mapa que puede llegar
		minScale: 1500000, // Lo más lejos del mapa que puede llegar
		maxExtent: bounds}; 	

	var renderer = OpenLayers.Util.getParameters(window.location.href).renderer;
	renderer = (renderer) ? [renderer] : OpenLayers.Layer.Vector.prototype.renderers;

	map = new OpenLayers.Map('map', options);  

	var wmslayerOrtoUrb = new OpenLayers.Layer.WMS(
		"GranCanaria",                    		        
		"http://idecan1.grafcan.es/ServicioWMS/OrtoUrb?",
		{layers: 'OU'},
		{
			transitionEffect: 'resize',	//Realiza el efecto zoom sin perder la imagen de vista (evita fondos blancos)
			isBaseLayer: true
		} 
	);
	map.addLayer(wmslayerOrtoUrb);	     

	///////////////////////////////////////////////////////////////////////////////////////////////
	//CAPAS WFS
	///////////////////////////////////////////////////////////////////////////////////////////////
	saveStrategies = [];
	layersWFS = [];
	var layerVisibilityButtons = "";
	for(var i=0; i<nLayersWFS; i++){
		// Variables de salvado
		saveStrategies[i] = new OpenLayers.Strategy.Save({auto:true});
		saveStrategies[i].events.register("success", '', showSuccessMsg);
		saveStrategies[i].events.register("failure", '', showFailureMsg);
		// Creación de la capa
		layersWFS[i] = new OpenLayers.Layer.Vector(dataWFS[i][0], {
		strategies: [new OpenLayers.Strategy.Fixed(), saveStrategies[i]],
		protocol: new OpenLayers.Protocol.WFS({
			url: "http://193.145.155.8:8080/geoserver/wfs",
			featureType: dataWFS[i][1],
			featureNS: "http://www.mapmap.org/g4wd",	
			maxExtent: bounds,								
			geometryName: "location"					
		}),
		styleMap: dataWFS[i][2],
		renderers: renderer
		});
		// Creación de su botón de visibilidad
		layerVisibilityButtons = layerVisibilityButtons 
			+ "<label for='chk" + i + "'>" + dataWFS[i][0] + "</label>"
			+ "<input type='checkbox' id='chk" + i + "' name='visibility' checked>";
		// Opciones de selección de capa
		if(i === 0){
			strControles = strControles 
				+ "<option value='" + i + "' selected='selected'>" + dataWFS[i][0] + "</option>";
		}else{
			strControles = strControles 
				+ "<option value='" + i + "'>" + dataWFS[i][0] + "</option>";
		}
		
	}
	map.addLayers(layersWFS);

	$('#cuerpoCapas').html(layerVisibilityButtons);
	$('#cuerpoCapas').trigger("create");

	// Contenido de controles cuando se está logueado
	strControles= "<input type='button' value='Modo Navegación' id='Navegar'>"			
	+"<h3>Menú</h3>"
	+"<p>Capa a modificar:</p>"
	+"<select id='listbox'>"
		+strControles		
    +"</select>"
    +"<p>Acción sobre la capa:</p>"
    +"<label for='check2'>Añadir</label>"
	+"<input type='radio' name='herramientas' id='check2'>"
	+"<label for='check3'>Editar</label>"
	+"<input type='radio' name='herramientas' id='check3' checked='checked'>"
	+"<label for='check4'>Quitar</label>"
	+"<input type='radio' name='herramientas' id='check4'>";


	///////////////////////////// add the custom editing toolbar
	var panel = new OpenLayers.Control.Panel(
		{'displayClass': 'customEditingToolbar'}
	);


	///////////////////////////////////////////////////////////////////////////////////////////////
	//VARIABLES DE NAVEGACIÓN
	///////////////////////////////////////////////////////////////////////////////////////////////		
	navigate = new OpenLayers.Control.Navigation({title: "Navegador"});			

	
	///////////////////////////////////////////////////////////////////////////////////////////////
	//VARIABLES DE BOTONES DE DIBUJO
	///////////////////////////////////////////////////////////////////////////////////////////////				
	dibujar = new OpenLayers.Control.DrawFeature(
		layersWFS[2], 
		OpenLayers.Handler.Point,
		{multi: true});			


	///////////////////////////////////////////////////////////////////////////////////////////////
	//VARIABLES DE BOTONES DE MODIFICACION
	///////////////////////////////////////////////////////////////////////////////////////////////					
	editar = new OpenLayers.Control.ModifyFeature(layersWFS[2],{vertexRenderIntent: "vertex"});
	 

	///////////////////////////////////////////////////////////////////////////////////////////////
	//VARIABLES DE BOTONES DE BORRADO
	///////////////////////////////////////////////////////////////////////////////////////////////					 
	borrado = new DeleteFeature(layersWFS[2]);	 
	

	///////////////////////////////////////////////////////////////////////////////////////////////
	//SELECCIÓN DE FEATURES (Modo PopUp)
	///////////////////////////////////////////////////////////////////////////////////////////////
	// inicio highlight mouseover
    var report = function(e) {
        OpenLayers.Console.log(e.type, e.feature.id);
    };


    highlightCtrl = new OpenLayers.Control.SelectFeature(layersWFS, {
        hover: true,
        highlightOnly: true,
        renderIntent: "temporary",
        eventListeners: {
            beforefeaturehighlighted: report,
            featurehighlighted: report,
            featureunhighlighted: report
        }
    });
 
    selectCtrl = new OpenLayers.Control.SelectFeature(layersWFS, {
        clickout: true
    });
 
    map.addControl(highlightCtrl);
    map.addControl(selectCtrl);
 
    highlightCtrl.activate();
    selectCtrl.activate();
	 
	/* END HIGHLIGHT */


	// Especifica qué ocurre cuando se selecciona o deselecciona un elemento.
    selectControl = new OpenLayers.Control.SelectFeature(layersWFS, {
        onSelect: onFeatureSelect, 
       	onUnselect: onFeatureUnselect,
        //multiple: false,
       	//box: true
    });
    map.addControl(selectControl);
    selectControl.activate();


	///////////////////////////////////////////////////////////////////////////////////////////////
	//EVENTOS DE LAS CAPAS
	///////////////////////////////////////////////////////////////////////////////////////////////
	for(var i=0; i<nLayersWFS; i++){
		layersWFS[i].events.on({
			  'beforefeaturemodified': function(evt) {
			      onFeatureSelect(evt.feature);
			  },
			  'featuremodified': function(evt){
			  	  onFeatureChange(evt.feature);
			  },
			  'afterfeaturemodified': function(evt) {
			      onFeatureUnselect(evt.feature);
			  },
			  'beforefeatureadded': function (evt) {
			  	onFeatureAdded(evt.feature);
			  },
			  'featureadded': function(evt) {
			  	if(isANewFeature){
			    	onFeatureSelect(evt.feature);
			    	isANewFeature = false;
			  	}
			  }
	    });
	}

	panel.addControls([navigate, dibujar, editar, borrado]);
	panel.defaultControl = navigate;
	map.addControl(panel);
	panel.deactivate(); //hacemos invisible el panel (pero se pueden seguir usando sus funciones)


 	///////////////////////////////////////////////////////////////////////////////////////////////
	// CENTRADO DEL MAPA
	///////////////////////////////////////////////////////////////////////////////////////////////
	var lonlat = new OpenLayers.LonLat(455523.35659,3105212.10947).transform(WGS84, WGS84_google_mercator);
	map.setCenter(lonlat,zoom); 
	

	///////////////////////////////////////////////////////////////////////////////////////////////
	// INICIALIZACIÓN DE VALORES
	///////////////////////////////////////////////////////////////////////////////////////////////
	isAPopUp = true; isANewFeature = false; isAnUpdate = false;
	$("#myEditor").jqte();
	$('#map').height($(window).height() - 140);
	$('#map').width($(window).width() - 32);
	map.updateSize();

  	if($.cookie("CONECTEDTOGEO"))
  	{
  		usuario = $.cookie("CONECTEDTOGEO");
        $("#registro").html(			        	
        	"<p>Conectado como <span style='color:blue; font-weight:bold; font-style:italic;'>"
        	+usuario
        	+"</span></p>"			        	
        	+"<input type='button' value='Salir' id='logout'>"
        	+"<hr>"	
        	+"<form action='http://193.145.155.8/index.php'>"
			+"<input type='hidden' name='userid' value='"+ usuario +"'>"	
			+"<input type='submit' value='Opciones Avanzadas'>"
			+"</form>"			        	
        );
        $('#registro').trigger("create");

		$('#controles').html(strControles);
		$('#controles').trigger("create");
		// Repinta el estilo móvil en los elementos añadidos
		
		desactivar();
		isAPopUp = false;						
		$('#listbox').trigger('change');
		editar.activate();
		mostrar(false);
		infoReport();
		estiloModo("Edición");
	}



	//////////////////////////////////////////////////////////////////////////////////////////////////////        
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// EVENTOS DE LA INTERFAZ
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////////////////////////
	// REDIMENSIONAR VENTANA
	///////////////////////////////////////////////////////////////////////////////////////////////
	$(window).resize(function () {
        $('#map').height($(window).height() - 140);
		$('#map').width($(window).width() - 32);
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	// MOSTRAR/OCULTAR CAPAS (modo navegación)
	///////////////////////////////////////////////////////////////////////////////////////////////
	$("input[name='visibility']").click(function() {
		for(var i=0; i<nLayersWFS; i++){
				if($('#chk'+i).is(':checked'))
					layersWFS[i].setVisibility(true);
				else{
					if(selectedFeature)
						onPopupClose();
					layersWFS[i].setVisibility(false);
			}	
		}	
	});	

	///////////////////////////////////////////////////////////////////////////////////////////////
	// ACTUALIZACIÓN TRAS CAMBIO DEL DESPLEGABLE DE CAPAS
	///////////////////////////////////////////////////////////////////////////////////////////////
	$('body').on('change', '#listbox',function(){
		desactivar();
		// "Parseamos" la string obtenida a entero para usarla como índice
		changeControls(layersWFS[parseInt($('#listbox').val())]);	

		mostrar(false);
		if($('#check2').is(':checked'))
			dibujar.activate();
		else if($('#check3').is(':checked'))
			editar.activate();
        else if($('#check4').is(':checked'))
        	borrado.activate();
        infoReport();
	});

		
	//////////////////////////////////////////////////////////////////////////////////////////////
	// ACTUALIZACIÓN TRAS SELECCIÓN DE HERRAMIENTA
	//////////////////////////////////////////////////////////////////////////////////////////////		
	$('body').on('change', '[type="radio"]', function(){ 
		desactivar();
		if ($('#check2').is(':checked')) {			
			dibujar.activate();
		}
		else if ($('#check3').is(':checked')) {
			editar.activate();
		}
		else if ($('#check4').is(':checked')) {
			borrado.activate();
		}	
		mostrar(false);	
		infoReport();		
	});

	//////////////////////////////////////////////////////////////////////////////////////////////
	// BOTÓN DE LOGUEO (LOGUEO + MODO EDICIÓN)
	//////////////////////////////////////////////////////////////////////////////////////////////				
	$('body').on('click', '#login', function() {
		login();
	});	


	///////////////////////////////////////////////////////////////////////////////////////////////
	// CODIGO DE DESLOGUEO
	///////////////////////////////////////////////////////////////////////////////////////////////
	$('body').on('click', '#logout', function() {
		$.cookie("CONECTEDTOGEO", usuario, { expires: -1 });
		$("#registro").html(
				"<input type='text' id='user' placeholder='Usuario'>"
				+"<input type='password' id='pass' placeholder='Contraseña'>"
				+"<input type='button' value='Modo Edición' id='login'>"
		);
		$('#registro').trigger("create");
		$('#controles').html("");
		desactivar();
		navigate.activate();			
		highlightCtrl.activate();
		selectCtrl.activate();			
		selectControl.activate();
		mostrar(true);
		isAPopUp = true;
		$("#Menu").panel( "close" );
		infoReport();
		estiloModo("Navegación");

		var ajax = $.ajax({
	        data : {userid:usuario},
	        type : "POST",
	        url : "http://193.145.155.8/logout.php",
	        //async: false
		});
	 	// callback handler that will be called on success
	    ajax.done(function (response, textStatus, jqXHR){
	        // log a message to the console
	        console.log("Conexion deslogueo correcta. " + response);
	    });

	    // callback handler that will be called on failure
	    ajax.fail(function (jqXHR, textStatus, errorThrown){
	        // log the error to the console
	        console.error(
	            "Conexion deslogueo fallida. "+
	            textStatus, errorThrown
	        );
	    });
		
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	// ALTERNAR EDICIÓN/NAVEGACIÓN
	///////////////////////////////////////////////////////////////////////////////////////////////
	$('body').on('click', '#Navegar', function() {
		desactivar();
		if($('#Navegar').val() === 'Modo Navegación')
		{
	        $("#controles").html(			        	
        		"<input type='button' value='Modo Edición' id='Navegar'>"
        	);				
			navigate.activate();			
			highlightCtrl.activate();
    		selectCtrl.activate();			
    		selectControl.activate();
			mostrar(true);
			isAPopUp = true;
			// Se actualiza info solo aquí porque el evento change del listbox incluye un infoReport
			infoReport();
			estiloModo("Navegación");
		}else{
	        $("#controles").html(strControles);
			isAPopUp = false;
			$('#listbox').trigger('change');				
			mostrar(false);			
			estiloModo("Edición");	
		}			
		// Repinta el estilo móvil en los elementos añadidos
		$('#controles').trigger("create");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	// PULSACIÓN DE ENTER EN CAJAS DE TEXTO USUARIO Y CONTRASEÑA
	///////////////////////////////////////////////////////////////////////////////////////////////
	$('body').on('keypress', '#user',function(event) {
        enterClick(event);
	});	
	$('body').on('keypress', '#pass',function(event) {
        enterClick(event);
	});		


	///////////////////////////////////////////////////////////////////////////////////////////////
	// ACTUALIZACIÓN SLIDERS DE COLORES
	///////////////////////////////////////////////////////////////////////////////////////////////
	$('body').on('change', '#lineColor',function(){
		lineColorVal = colores[$('#lineColor').val()];
		$('input#lineColor').css('background-color', lineColorVal);
		$('input#lineColor').val("");
	});
	$('body').on('change', '#fillColor',function(){
		fillColorVal = colores[$('#fillColor').val()];
		$('input#fillColor').css('background-color', fillColorVal);
		$('input#fillColor').val("");
	});
	$('body').on('click', '#refrescar',function(){
		for(var i=0; i<nLayersWFS; i++){
			layersWFS[i].refresh({force:true});
		}		
		console.log("refresco hecho");
	});
});	



//////////////////////////////////////////////////////////////////////////////////////////////////////        
//////////////////////////////////////////////////////////////////////////////////////////////////////
// FUNCIONES EXTRAS
//////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////
function showMsg(szMessage) {
	console.log(szMessage);
} 
function showSuccessMsg(){showMsg("Transaction successfully completed");};
function showFailureMsg(){showMsg("An error occured while operating the transaction");};

//////////////////////////////////////////////////////////////////////////////////////////////
// SALVADO
//////////////////////////////////////////////////////////////////////////////////////////////
function salvado(actualLayer) {
	if(editar.feature) {
		editar.selectControl.unselectAll();
	}
	saveStrategies[actualLayer].save();	
};


//////////////////////////////////////////////////////////////////////////////////////////////
// CAMBIO DE CONTROL ENTRE CAPAS
//////////////////////////////////////////////////////////////////////////////////////////////
/*Función que resetea los controles (destruyéndolos y creándolos de nuevo) para
  cuando se cambia de capa (reduce el código y facilita el manejo)*/
function changeControls(capa) {
    map.removeControl(dibujar);
    map.removeControl(editar);
    map.removeControl(borrado);
    dibujar.destroy();
    editar.destroy();
    borrado.destroy();

    // Obtenemos el índice de la capa
	var index = layersWFS.indexOf(capa);
	// Comprobamos que no sea erróneo   
	if(index === -1) console.log("funcion:changeControls. Error:no se ha obtenido el índice de la capa.")
	// Indicamos a la herramienta de dibujo la Capa (capa) y el tipo de elemento "punto, línea, polígono" (dataWFS[index][3])
	// haciendo uso del índice y de la tercera fila de la matriz de datos.		
	dibujar	= new OpenLayers.Control.DrawFeature(capa, dataWFS[index][3],{multi: true}); 
	// Comprobamos con la matriz de datos que el estilo no sea el de iconos personalizados, ya que estos requieren indicar que
	// harán uso del estilo "vertex"
	if(dataWFS[index][2] === GuaguaStyle)
    	editar = new OpenLayers.Control.ModifyFeature(capa, {vertexRenderIntent: "vertex"});
    else
    	editar = new OpenLayers.Control.ModifyFeature(capa);
    borrado = new DeleteFeature(capa);
    
    map.addControl(dibujar);
    map.addControl(editar);
    map.addControl(borrado);
};


//////////////////////////////////////////////////////////////////////////////////////////////
// ACTUALIZACIÓN DE FEATURE
//////////////////////////////////////////////////////////////////////////////////////////////
function onTriggerUpdate() {
  	isAnUpdate = true;

	for(x in selectedFeature.attributes){
		if(x === "lineacolor"){
			selectedFeature.attributes[x] = lineColorVal;
			continue;
		}
		if(x === "rellenocolor"){
			selectedFeature.attributes[x] = fillColorVal;
			continue;
		}
		if(x === "popup"){
			continue;
		}

		selectedFeature.attributes[x] = $("#"+x).val();
	}
	var index = layersWFS.indexOf(selectedFeature.layer);

	if(dataWFS[index][3] === OpenLayers.Handler.Point){
		selectedFeature.geometry.components[0].x = ($('#x0').val() || selectedFeature.geometry.components[0].x);
  		selectedFeature.geometry.components[0].y = ($('#y0').val() || selectedFeature.geometry.components[0].y);
	}
	if(dataWFS[index][3] === OpenLayers.Handler.Path){
  		//Actualización de los vértices (componentes) de la línea. Funciona del mismo modo en el polígono supongo
  		var componentes = selectedFeature.geometry.components[0]; 
  		for(var i = 0; i < componentes.components.length; i++){
  			var TempX = OpenLayers.Util.getElement('x' + i).value;
  			var TempY = OpenLayers.Util.getElement('y' + i).value;
  			if(componentes.components[i].x !== TempX && TempX)
  				componentes.components[i].x = TempX;
  			if(componentes.components[i].y !== TempY && TempY)
  				componentes.components[i].y = TempY;
  		}
	}	
	if(dataWFS[index][3] === OpenLayers.Handler.Polygon){
		//Actualización de los vértices (componentes) del polígono
		//(llego hasta la longitud -1 porque en el caso de los polígonos se "repite" el
		//primer vértice al final, indicando que ahí se cierra el polígono)
		var componentes = selectedFeature.geometry.components[0].components[0]; 
  		for(var i = 0; i < componentes.components.length-1; i++){
  			var TempX = OpenLayers.Util.getElement('x' + i).value;
  			var TempY = OpenLayers.Util.getElement('y' + i).value;
  			if(componentes.components[i].x !== TempX && TempX)
  				componentes.components[i].x = TempX;
  			if(componentes.components[i].y !== TempY && TempY)
  				componentes.components[i].y = TempY;
  		}
	}        
    selectedFeature.state = OpenLayers.State.UPDATE;
    var actualLayer;
    salvado(index);
    if ($('#check2').is(':checked'))onFeatureUnselect(selectedFeature);
};


//////////////////////////////////////////////////////////////////////////////////////////////
// CERRAR POPUP
//////////////////////////////////////////////////////////////////////////////////////////////
// Función para cerrar el popUp:
// básicamente se libera la selección para
// provocar la llamada al FeatureUnselect
function onPopupClose(evnt) {
    selectControl.unselect(selectedFeature);       
};

//////////////////////////////////////////////////////////////////////////////////////////////
// EDICION DEL CONTENIDO DEL POPUP
//////////////////////////////////////////////////////////////////////////////////////////////
function popUpEdit () {
	$("#popUpEditor").popup();
	$("#popUpEditor").popup("open");
	$("#myEditor").jqteVal(selectedFeature.attributes.popup);
};


//////////////////////////////////////////////////////////////////////////////////////////////
// CIERRE DE LA EDICION DEL CONTENIDO DEL POPUP
//////////////////////////////////////////////////////////////////////////////////////////////
function popUpEditClose () {
	selectedFeature.attributes.popup = $("#myEditor").val();
	$("#popUpEditor").popup();
	$("#popUpEditor").popup("close");
};


//////////////////////////////////////////////////////////////////////////////////////////////
// SELECCION DE FEATURE
//////////////////////////////////////////////////////////////////////////////////////////////
// Función para cuando se hace una selección
function onFeatureSelect(feature) {
	selectedFeature = feature;

	if (isAPopUp) // Creamos el PopUp
	{
		var content;
		content ="<div>"
				+ feature.attributes.popup
				+"</div>";

		var popup = new OpenLayers.Popup.FramedCloud(
				"chicken", 
	            feature.geometry.getBounds().getCenterLonLat(),
	            null,//new OpenLayers.Size(250, 100),
	            content,
	            null, 
	            true, 
	            onPopupClose);
        feature.popup = popup;
        map.addPopup(popup);
	}
	else // Hay seleccionada cualquier otra herramienta, por lo que mostramos todos los campos de la base de datos
	{
		var index = layersWFS.indexOf(feature.layer);
		// for(x in feature.attributes)console.log(feature.attributes[x]);
		var strCampos = "<h3>Campos</h3>"
						+"ID: <input type='text' name='id' id='id' value='" + feature.id + "' class='textboxReadOnly' readonly> <br/>\n"
						+"FID: <input type='text' name='fid' id='fid' value='"	+ feature.fid + "' class='textboxReadOnly' readonly> <br/>\n";								

		for(x in feature.attributes){
			switch (x)
			{
				case "popup": 
				  strCampos = strCampos
							+"<input type='button' value='Contenido PopUp' onclick='popUpEdit()'>\n";
				  break;

				case "icono": 
				  strCampos = strCampos + "icono: <select id='" + x + "'>";
					for (var i in lista_iconos) {
						if (feature.attributes[x] === lista_iconos[i])
							strCampos = strCampos + "<option value='" + lista_iconos[i] + "' selected='selected'>" + lista_iconos[i] + "</option>";
						else
							strCampos = strCampos + "<option value='" + lista_iconos[i] + "'>" + lista_iconos[i] + "</option>"		
						
					}
					strCampos = strCampos + "</select><br/>\n";	
				  break;

				case "lineacolor":
				  strCampos = strCampos
					+"Color de Línea:"
					+"<input type='range' id='lineColor' value=" + colores.indexOf(feature.attributes[x]) + " min='0' max='9'>"
					+ "<br/>\n";
					lineColorVal = feature.attributes[x];
				  break;

				case "rellenocolor":
				  strCampos = strCampos
					+"Color de Relleno:"
					+"<input type='range' id='fillColor' value=" + colores.indexOf(feature.attributes[x]) + " min='0' max='9'>"
					+ "<br/>\n";
					fillColorVal = feature.attributes[x];
				  break;

				case "strokewidth":
				  strCampos = strCampos
					+"Ancho de Línea:"
					+"<input type='range' id='strokeWidth' value=" + feature.attributes[x] + " min='3' max='10'>";
				  break;

				case "strokedashstyle":
				  strCampos = strCampos	
						+"Trama de Línea:"
						+"<select id='strokedashstyle'>"
							+"<option value='solid' selected='selected'>solid</option>"
							+"<option value='dot'>dot</option>"
							+"<option value='dash'>dash</option>"
							+"<option value='dashdot'>dashdot</option>"
							+"<option value='longdash'>longdash</option>"
							+"<option value='longdashdot'>longdashdot</option>"
				        +"</select>"
						+ "<br/>\n";
				  break;

				default:
				  strCampos = strCampos // Campos normales de texto que no requieren tratamiento especial
						+ x + ": <input type='text' name='"	+ x	+ "' id='" + x + "' value='" + feature.attributes[x] + "'> <br/>\n";
			}
		}
		strCampos = strCampos
			+ "UBICACIÓN (X,Y):"
			+ "<div id='CamposXY'></div>";
		var Campos = $("#Campos");
    	Campos.html(strCampos);

    	// En este punto se han añadido todo los posibles atributos al DIV Campos, solo queda añadir al DIV
    	// CamposXY los vértices del elemento

		var vertices = feature.geometry.getVertices();
		var strCamposXY = "";
		for(i in vertices)
			strCamposXY = strCamposXY
				+"<input type='text' name='geometria' id='x" + i + "' value='" + vertices[i].x + "'>"
				+"<input type='text' name='geometria' id='y" + i + "' value='" + vertices[i].y + "'>"
				+"<br/>\n";
		$('#CamposXY').html(strCamposXY);

		//Por último, añadimos botón de guardar o actualizar dependiendo de en qué parte de la aplicación estemos

		if(isANewFeature)
        	Campos.append("<input type='button' value='Guardar' onclick='onTriggerUpdate()'>");
		else
			Campos.append("<input type='button' value='Actualizar' onclick='onTriggerUpdate()'>");

		$('#Campos').trigger("create");

		if(dataWFS[index][3] === OpenLayers.Handler.Polygon){ 
			console.log("Función:onFeatureSelect Seleccionada: Capa polígono correctamente");
			$('input#lineColor').css("background-color",lineColorVal);
			$('input#lineColor').val("");
			$('input#fillColor').css("background-color",fillColorVal);
			$('input#fillColor').val("");
		}
		if(dataWFS[index][3] === OpenLayers.Handler.Path){
			console.log("Función:onFeatureSelect Seleccionada: Capa línea correctamente");
			$('input#lineColor').css("background-color",lineColorVal);
			$('input#lineColor').val("");
			if(feature.attributes.strokedashstyle){
				$('#strokeDashstyle').val(feature.attributes.strokedashstyle);
				$('#strokeDashstyle').selectmenu("refresh");
			}
		}
		$('#Datos').panel(
		    "open",
		    {
		      options: {
		        position: "right",
		        animate: false,
		        dismissable: false
		      }
		    }
		);
	}        
};


//////////////////////////////////////////////////////////////////////////////////////////////
// CAMBIO EN PROPIEDADES FEATURE
//////////////////////////////////////////////////////////////////////////////////////////////
function onFeatureChange (feature) {
	$('#CamposXY').html("");			
	var vertices = feature.geometry.getVertices();
	for(i in vertices)
		$('#CamposXY').append(
			"<input type='text' name='geometria' id='x" + i	+ "' value='" + vertices[i].x + "'>"
			+"<input type='text' name='geometria' id='y" + i + "' value='" + vertices[i].y + "'>"
			+"<br/>\n");
	$('#CamposXY').trigger("create");
};

//////////////////////////////////////////////////////////////////////////////////////////////
// FEATURE AÑADIDO
//////////////////////////////////////////////////////////////////////////////////////////////
function onFeatureAdded(feature) {
	if(feature.fid === null){
		selectedFeature = feature;
		isANewFeature = true;
		var index = layersWFS.indexOf(feature.layer);

		for(var x in dataWFS[index][4]){
			var strValue = dataWFS[index][4][x];
			switch (strValue)
			{
				case "icono":
				  feature.attributes[strValue] = "default_icon.png";
				  break;
				case "lineacolor":
				  feature.attributes[strValue] = "#EFBA00";
				  break;
				case "rellenocolor":
				  feature.attributes[strValue] = "#FECE2F";
				  break;
				case "strokewidth":
				  feature.attributes[strValue] = 6;
				  break;
				case "strokedashstyle":
				 feature.attributes[strValue] = "solid";
				  break;
				default:
				  feature.attributes[strValue] = strValue;
			}
		}	
	}
};


//////////////////////////////////////////////////////////////////////////////////////////////
// FEATURE DESELECCIONADO
//////////////////////////////////////////////////////////////////////////////////////////////
// Función para cuando se quita la selección
function onFeatureUnselect(feature) {
	if (isAPopUp){
    	map.removePopup(feature.popup);
    	feature.popup.destroy();
    	feature.popup = null;	  	
    }else{
    	var index = layersWFS.indexOf(feature.layer);
    	// Refresco la capa modificada y tras medio segundo para que de tiempo a guardarse los cambios
    	if(!isAnUpdate && dataWFS[index][2] === GuaguaStyle)
    		setTimeout(function(){
    			feature.layer.redraw({force:true});
    			console.log("listo");
    		},100);
    	else{
	    	if(isAnUpdate || dataWFS[index][2] === GuaguaStyle)
	    		setTimeout(function(){
	    			feature.layer.refresh({force:true});
	    			console.log("listo");
	    		},100);
    	}
    	isAnUpdate = false;
    	
    	$("#Campos").html("<h3>Campos</h3><p>No hay ningún elemento seleccionado</p>");
    	$('#Datos').panel('close');
    }    		
	selectedFeature = undefined;
	if($('#check2').is(':checked')){
		//lo lanzo dos veces porque si lo hago solo una no cambia la selección en el radiobutton
		// Esto se debe a que el radio button tiene asociado un label por lo que el primer click se asocia
    	// al label y luego el siguiente para cambiar el boton seleccionado
		$('#check3').trigger('click');
		$('#check3').trigger('click');
	}
};


//////////////////////////////////////////////////////////////////////////////////////////////
// DESACTIVAR CONTROLES
//////////////////////////////////////////////////////////////////////////////////////////////	
function desactivar () {
	// Deselecciona features o Borra PopUps
	if(editar.feature) 
		editar.selectControl.unselectAll();		
	if(selectedFeature)				
		selectControl.unselect(selectedFeature); 			
	//Desactiva todas las herramientas del mapa
	navigate.deactivate();
	dibujar.deactivate();
	editar.deactivate();
	borrado.deactivate();
	selectControl.deactivate();
	highlightCtrl.deactivate();
	selectCtrl.deactivate();
	isAPopUp = false;
};


///////////////////////////////////////////////////////////////////////////////////////////////
// MOSTRAR/OCULTAR CAPAS (modo edición)
///////////////////////////////////////////////////////////////////////////////////////////////
function mostrar (value) {
	for(var i=0; i<nLayersWFS; i++){
		layersWFS[i].setVisibility(value);
		$('#chk'+i).prop("checked",value).checkboxradio("refresh");
	}		
	if(!value){
		var index = parseInt($('#listbox').val());
		layersWFS[index].setVisibility(true);
		$('#chk'+index).prop("checked",true).checkboxradio("refresh");
	}
};


//////////////////////////////////////////////////////////////////////////////////////////////
// CÓDIGO DE LOGUEO
//////////////////////////////////////////////////////////////////////////////////////////////		
//Codigo AJAX
function login () {
	var options = {
	    user:$("#user").val(), //geoserver user
	    password: $("#pass").val(), 
	    server : "http://193.145.155.8:8080", //geoserver host
	    success : function(){		
	    	usuario = $("#user").val();
	        $.cookie("CONECTEDTOGEO", usuario, { expires: 2 });
	        $("#registro").html(			        	
	        	"<p>Conectado como <span style='color:blue; font-weight:bold; font-style:italic;'>"
	        	+usuario
	        	+"</span></p>"			        	
	        	+"<input type='button' value='Salir' id='logout'>"
	        	+"<hr>"			
	        	+"<form action='http://193.145.155.8/index.php'>"
				+"<input type='hidden' name='userid' value='"+ usuario +"'>"	
				+"<input type='submit' value='Opciones Avanzadas'>"
				+"</form>"	        	
	        );
	        $('#registro').trigger("create");
			$('#controles').html(strControles);
			$('#controles').trigger("create");
			// Repinta el estilo móvil en los elementos añadidos
			
			desactivar();
			isAPopUp = false;						
			$('#listbox').trigger('change');
			//editar.activate();
			mostrar(false);
			infoReport();
			estiloModo("Edición");
	    },
	    failure : function(){
	        alert("Imposible conectar con el servidor.");
	    }
	};


	if(options["user"] == "" || options["password"] == ""){
		options.failure();
		return;
	}

    if($.cookie("CONECTEDTOGEO")!=null){
    	usuario = $.cookie("CONECTEDTOGEO");
    	$.cookie("CONECTEDTOGEO", usuario, { expires: -1 });
    }
	

    	
    // url del servlet del geoserver
    var url = options.server + "/geoserver/j_acegi_security_check";
    // parametros para el login
    params = "username=" + options["user"] + "&password="
                + options["password"];

    var contentType = "application/x-www-form-urlencoded";
    //se inicializa la petición ajax
    var ajax = $.ajax({
        data : params,
        type : "POST",
        contentType : contentType,
        url : url
	});

	// se ejecuta cuando la peticion finaliza
	ajax.done(function(data) {
		//console.log(data);
		if(/Combinación de usuario y contraseña inválida/.test(data)){ 
			// avisamos al usuario de que no se ha registrado
			alert("Usuario o Contraseña inválido.");
			$('#pass').val("");
			// salimos sin realizar cambios
			return;
		}
	    if ($.cookie("JSESSIONID") != null && options && options.success) {
	        options.success();
	        $.ajax({
				data: {user: options["user"],pass: options["password"]}, 
				type: "POST",
	            url: "http://193.145.155.8/validar_usuario.php",
	            async: false, // Evita que continue la ejecución hasta que se haya obtenido todo lo requerido
	            //cache: false, 	            
	            success: function(result) {
	               console.log("logueo en php correcto. " + result);
	            },
	            failure: function(result) {
	            	console.log("Error de logueo en php: " + result);
	            }
        	});
	    }
	});
	
	// si ocurrio un error al realizar la peticion
	ajax.fail(function(data) {
	    if (options && options.failure) {
	        options.failure(data);
	    }
	});
	
	// se ejecuta siempre al final de la petición, sin importar que esta
	// haya fallado
	ajax.always(function() {
	    if (options && options.always) {
	        options.always();
	    }
	});
};	


//////////////////////////////////////////////////////////////////////////////////////////////
// COMPROBACIÓN DE PULSAR "ENTER" CUANDO SE VA A LOGUEAR
//////////////////////////////////////////////////////////////////////////////////////////////				
function enterClick(event){
	if (event.keyCode == 13) {
    	if($('#user').val() != "" && $('#pass').val() != "")
    		login();	            
    	else
    		alert("Usuario o Contraseña inválido.");
    }
};


///////////////////////////////////////////////////////////////////////////////////////////////
// ESTILO SEGUN MODO (navegación, edición)
///////////////////////////////////////////////////////////////////////////////////////////////
function estiloModo (tipo) {
	if(tipo === "Edición"){
		for(var i=0; i<nLayersWFS; i++){
			if(dataWFS[i][2] === GuaguaStyle)
				layersWFS[i].styleMap.styles['temporary'].defaultStyle.externalGraphic = "img/default_icon.png";
		}
	}
	if(tipo === "Navegación"){
		for(var i=0; i<nLayersWFS; i++){
			if(dataWFS[i][2] === GuaguaStyle)
				layersWFS[i].styleMap.styles['temporary'].defaultStyle.externalGraphic = "img/${icono}";
		}		
	}
};	


///////////////////////////////////////////////////////////////////////////////////////////////
// INFORMACION DE AYUDA
///////////////////////////////////////////////////////////////////////////////////////////////
function infoReport () {
	if(isAPopUp){ // Navegar
		$('#Info').html("Clic/Toque de dedo sobre un elemento para más info. Doble clic/toque para zoom. Rueda del Ratón/Pinzas para acercar/alejar");
		return;
	}
	if($('#listbox').val() === "2" && $('#check2').is(':checked')){ // Añadir - Guaguas
		$('#Info').html("Clic/Toque en cualquier lugar del mapa para añadir un elemento");
		return;
	}
	if($('#listbox').val() === "1" && $('#check2').is(':checked')){ // Añadir - Rutas
		$('#Info').html("Clic/Toque para empezar el trazo. Clicar/tocar para añadir vértices. Doble clic/toque para finalizar el trazo");
		return;
	}
	if($('#listbox').val() === "0" && $('#check2').is(':checked')){ // Añadir - Edificios
		$('#Info').html("Clic/Toque para empezar la forma. Clicar/Tocar para añadir vértices. Doble clic/toque para finalizar la forma");
		return;
	}
	if($('#listbox').val() === "2" && $('#check3').is(':checked')){ // Editar - Guaguas
		$('#Info').html("Clic/Toque sobre un elemento para seleccionarlo. Arrastrar para moverlo. Clicar en <img src="
						+'"img/etiqueta.png"'
						+");' /> para ver sus atributos. Clic/Toque en el mapa para deseleccionar.");
		return;
	}
	if($('#listbox').val() === "1" && $('#check3').is(':checked')){ // Editar - Rutas
		$('#Info').html("Clic/Toque sobre un elemento para seleccionarlo. Clic/Toque + arrastrar para mover uno de sus vértices."
						+"Clicar en <img src="
						+'"img/etiqueta.png"'
						+");' /> para ver sus atributos. Clic/Toque en el mapa para deseleccionar.");
		return;
	}
	if($('#listbox').val() === "0" && $('#check3').is(':checked')){ // Editar - Edificios
		$('#Info').html("Clic/Toque sobre un elemento para seleccionarlo. Clic/Toque + arrastrar para mover uno de sus vértices."
						+"Clicar en <img src="
						+'"img/etiqueta.png"'
						+");' /> para ver sus atributos. Clic/Toque en el mapa para deseleccionar.");
		return;
	}
	if(($('#listbox').val() === "2" && $('#check4').is(':checked'))
	||($('#listbox').val() === "1" && $('#check4').is(':checked'))
	||($('#listbox').val() === "0" && $('#check4').is(':checked'))){ // Quitar - Para las tres capas
		$('#Info').html("Clic/Toque en un elemento para eliminarlo.");
		return;
	}
};