<?php
	session_start();
	if(isset($_SESSION['k_username'])){

		$crear_tabla = 'CREATE TABLE ';
		if(trim($_POST["nombrecapa"]) != ""){

			// Instrucción para crear la tabla
			if($_POST["tipocapa"] == 'punto'){
				if($_POST["tipoestilo"] == 'especial')
					$crear_tabla = $crear_tabla . trim($_POST["nombrecapa"]) .'(id int, popup TEXT, icono TEXT';
				if($_POST["tipoestilo"] == 'defecto')
					$crear_tabla = $crear_tabla . trim($_POST["nombrecapa"]) .'(id int, popup TEXT';
			}
			if($_POST["tipocapa"] == 'linea'){
			   $crear_tabla = $crear_tabla . trim($_POST["nombrecapa"]) .'(id int, popup TEXT, lineacolor TEXT, strokewidth TEXT, strokedashstyle TEXT';
			}
			if($_POST["tipocapa"] == 'poligono'){
			   $crear_tabla = $crear_tabla . trim($_POST["nombrecapa"]) .'(id int, popup TEXT, lineacolor TEXT, rellenocolor TEXT';
			}			
			

			if(trim($_POST["campo1"]) != ""){
				$crear_tabla = $crear_tabla . ', ' . trim($_POST["campo1"]) . ' TEXT';
			}
			if(trim($_POST["campo2"]) != ""){
				$crear_tabla = $crear_tabla . ', ' . trim($_POST["campo2"]) . ' TEXT';
			}
			if(trim($_POST["campo3"]) != ""){
				$crear_tabla = $crear_tabla . ', ' . trim($_POST["campo3"]) . ' TEXT';
			}
			if(trim($_POST["campo4"]) != ""){
				$crear_tabla = $crear_tabla . ', ' . trim($_POST["campo4"]) . ' TEXT';
			}
			$crear_tabla = $crear_tabla . ')';		

			// Instrucción para definir la geometría
			$addgeometry = 'SELECT AddGeometryColumn(' 
							. '\'' . trim($_POST["nombrecapa"]) . '\''
							. ', \'location\', 32628, ';
			if($_POST["tipocapa"] == 'punto'){
				$addgeometry = $addgeometry . '\'MULTIPOINT\', 2)';
			}
			if($_POST["tipocapa"] == 'linea'){
				$addgeometry = $addgeometry . '\'MULTILINESTRING\', 2)';
			}
			if($_POST["tipocapa"] == 'poligono'){
				$addgeometry = $addgeometry . '\'MULTIPOLYGON\', 2)';
			}

			// Instrucción para definir la clave primaria
			$alteracion = 'ALTER TABLE ' . trim($_POST["nombrecapa"]) . ' ADD PRIMARY KEY (id)';


			//AQUI CONECTAMOS A LA BASE DE DATOS DE POSTGRES
			$conex = "host=localhost port=5432 dbname=g4wd user=postgres password=ma.pas.2010";
			$cnx = pg_connect($conex) or die ("<h1>Error de conexion.</h1> ". pg_last_error());


			$result = pg_query($crear_tabla);		
			if (!$result) {
				echo "Error en creacion de capa(1).<br>";
				echo '<a href=\'http://193.145.155.8/index.php?userid=' . $_SESSION['k_username'] . '\'>volver a Opciones</a> | 
				  <a href=\'http://193.145.155.8:8080/geoserver/www/OpenLayers-2.12/final/index.html\'>volver al mapa</a>';
				exit;
			}else{
				echo "Paso 1 completado con éxito.<br>"; 
			}


			$result = pg_query($addgeometry);		
			if (!$result) {
				// pg_query('DROP TABLE' . trim($_POST["nombrecapa"]) );
				echo "Error en creacion de capa(2).<br>";
				echo '<a href=\'http://193.145.155.8/index.php?userid=' . $_SESSION['k_username'] . '\'>volver a Opciones</a> | 
				  <a href=\'http://193.145.155.8:8080/geoserver/www/OpenLayers-2.12/final/index.html\'>volver al mapa</a>';
				exit;
			}else{
				echo "Paso 2 completado con éxito.<br>"; 
			}			

			$result = pg_query($alteracion);		
			if (!$result) {
				// pg_query('DROP TABLE' . trim($_POST["nombrecapa"]) );
				echo "Error en creacion de capa(3).<br>";
				echo '<a href=\'http://193.145.155.8/index.php?userid=' . $_SESSION['k_username'] . '\'>volver a Opciones</a> | 
				  <a href=\'http://193.145.155.8:8080/geoserver/www/OpenLayers-2.12/final/index.html\'>volver al mapa</a>';
				exit;
			}else{
				echo "Paso 3 completado con éxito.<br>"; 
			}						

			// Instrucción para añadir en la tabla datawfs la información para mostrar la capa
			$datosWFS = 'INSERT INTO datawfs VALUES(';
			if(trim($_POST["descripcioncapa"]) != ""){
				$datosWFS = $datosWFS . '\'' . $_POST["descripcioncapa"] .'\'';
			}
			else{
				$datosWFS = $datosWFS . '\'' . trim($_POST["nombrecapa"]) . '\'';
			}

			$datosWFS = $datosWFS . ', \'' . trim($_POST["nombrecapa"]) . '\'';
			if($_POST["tipoestilo"] == 'defecto'){
				$datosWFS = $datosWFS . ', \'myStyles\'';
			}
			if($_POST["tipoestilo"] == 'especial'){
				$datosWFS = $datosWFS . ', \'GuaguaStyle\'';
			}

			if($_POST["tipocapa"] == 'punto'){
				if($_POST["tipoestilo"] == 'especial')
					$datosWFS = $datosWFS . ', \'OpenLayers.Handler.Point\', \'[\"popup\",\"icono\"';
				if($_POST["tipoestilo"] == 'defecto')
					$datosWFS = $datosWFS . ', \'OpenLayers.Handler.Point\', \'[\"popup\"';
			}
			if($_POST["tipocapa"] == 'linea'){
				$datosWFS = $datosWFS . ', \'OpenLayers.Handler.Path\', \'[\"popup\",\"lineacolor\",\"strokewidth\",\"strokedashstyle\"';
			}
			if($_POST["tipocapa"] == 'poligono'){
				$datosWFS = $datosWFS . ', \'OpenLayers.Handler.Polygon\', \'[\"popup\",\"lineacolor\",\"rellenocolor\"';
			}

			if(trim($_POST["campo1"]) != ""){
				$datosWFS = $datosWFS . ',\"' . trim($_POST["campo1"]) . '\"';
			}
			if(trim($_POST["campo2"]) != ""){
				$datosWFS = $datosWFS . ',\"' . trim($_POST["campo2"]) . '\"';
			}
			if(trim($_POST["campo3"]) != ""){
				$datosWFS = $datosWFS . ',\"' . trim($_POST["campo3"]) . '\"';
			}
			if(trim($_POST["campo4"]) != ""){
				$datosWFS = $datosWFS . ',\"' . trim($_POST["campo4"]) . '\"';
			}	
			$datosWFS = $datosWFS . ']\')';		

			$result = pg_query($datosWFS);		
			if (!$result) {
				// pg_query('DELETE FROM datawfs WHERE tablename =\'' . trim($_POST["nombrecapa"]) . '\'' );
				// pg_query('DROP TABLE' . trim($_POST["nombrecapa"]) );
				echo "Error en actualizacion de informacion.<br>";
				echo '<a href=\'http://193.145.155.8/index.php?userid=' . $_SESSION['k_username'] . '\'>volver a Opciones</a> | 
				  <a href=\'http://193.145.155.8:8080/geoserver/www/OpenLayers-2.12/final/index.html\'>volver al mapa</a>';
				exit;
			}else{
				echo "Paso 4 completado con éxito.<br>";
			}
			pg_close();

			include "GeoserverWrapper.php";
			$geoserver = new GeoserverWrapper('http://193.145.155.8:8080/geoserver','admin', 'geoserver');
			$geoserver->createPostGISDataStore(
				trim($_POST["nombrecapa"]), // Nombre almacén de datos
				'G4WD', 					// Nombre del espacio de trabajo
				'g4wd', 					// Nombre BD
				'postgres', 				// Usuario BD
				'ma.pas.2010');				// Pass
			echo '<br>';
			$geoserver->createLayer(
				trim($_POST["nombrecapa"]), // Nombre de la capa
				'G4WD', 					// Nombre del espacio de trabajo
				trim($_POST["nombrecapa"]));// Nombre del almacén de datos

			echo '<br>';
			echo 'Exito en creacion de capa.<br>';
			echo '<a href=\'http://193.145.155.8/index.php?userid=' . $_SESSION['k_username'] . '\'>volver a Opciones</a> | 
				  <a href=\'http://193.145.155.8:8080/geoserver/www/OpenLayers-2.12/final/index.html\'>volver al mapa</a>';
		}
	}

?>